RAPL-INFO(1)

NAME

rapl-info - get RAPL configurations

SYNPOSIS

rapl-info [OPTION]...

DESCRIPTION

This utility is deprecated, use powercap-info(1) instead.

Prints out Intel Running Average Power Limit (RAPL) configurations.

Note that the -p and -z options are different from powercap-info(1).

This software requires an Intel processor (Sandy Bridge or newer), Linux kernel 3.13 or newer compiled with CONFIG_POWERCAP and CONFIG_INTEL_RAPL enabled, and the intel_rapl kernel module to be loaded.

OPTIONS

-h, --help
    Prints out the help screen

-v, --verbose
    Print errors when files are not available

-p, --zone=ZONE
    The zone number (none by default; 0 by default if using -z/--subzone and/or -c/--constraint). Ending with a colon prevents output for subzones. E.g., for zone 0, but not subzones:
    -p 0:

-p, --package=PACKAGE
    Deprecated, use --zone instead

-z, --subzone=SUBZONE
    The subzone number (none by default)

-c, --constraint=CONSTRAINT
    The constraint number (none by default)

All remaining options below are mutually exclusive:

-n, --nzones
    Print the number of zones found, or the number of subzones found if -p/--zone is set

The following are zone-level arguments (-z/--subzone is optional):

-j, --z-energy
    Print zone energy counter

-J, --z-max-energy-range
    Print zone maximum energy counter range

-w, --z-power
    Print zone current power

-W, --z-max-power-range
    Print zone maximum current power range

-e, --z-enabled
    Print zone enable/disabled status

-x, --z-name
    Print zone name

The following are constraint-level arguments and require -c/--constraint (-z/--subzone is optional):

-l, --c-power-limit
    Print constraint power limit

-s, --c-time-window
    Print constraint time window

-U, --c-max-power
    Print constraint maximum allowed power

-u, --c-min-power
    Print constraint minimum allowed power

-T, --c-max-time-window
    Print constraint maximum allowed time window

-t, --c-min-time-window
    Print constraint minimum allowed time window

-y, --c-name
    Print constraint name

EXAMPLES

Note that -p/--zone=0 is used by default when also specifying -z/--subzone and/or -c/--constraint, allowing for simpler commands on single-socket systems.

rapl-info
    Print all RAPL zones.

rapl-info -p 0
    Print only zone 0, which is usually named package-0.

rapl-info -p 0 -z 1
    Print zone 0, subzone 1, which is usually the uncore or dram subzone of package-0, depending on the system.

rapl-info -p 0 -c 1
    Print zone 0, constraint 1, which is usually the short_term constraint for package-0.

rapl-info -p 0 -j
    Print the energy counter for zone 0, which is usually named package-0.

rapl-info -p 1 -z 0 -c 0 -l
    Print the power limit for zone 1, subzone 0, constraint 0, which is usually the long_term constraint for the core subzone of package-1 (a multi-socket system).

REMARKS

Some fields are optional and will only be printed if they are available unless -v/--verbose is set.
If no zone/constraint-specific outputs are requested, all available zones and constraints will be shown.

Energy units: microjoules (uJ)
Power units: microwatts (uW)
Time units: microseconds (us)

BUGS

The following are behavioral quirks due to the kernel interface or abnormalities in some hardware. They are not bugs in rapl-info and should not be reported as such.

Values returned by the kernel sometimes lose accuracy from the actual values stored in Model-Specific Registers due to integer rounding. For example, the kernel may return a time window value of 7812 us, when in fact the actual stored value is 7812.5 us. Writing back a value returned by the kernel, e.g., using rapl-set(1), may cause unexpected changes to its value due to these rounding problems.

At the time of this writing, some features in the powercap interface are not supported by RAPL. The following options may result in ENOENT (No such file or directory) errors:
  -w/--z-power
  -W/--z-max-power-range
  -u/--c-min-power
  -T/--c-max-time-window
  -t/--c-min-time-window

On some systems, the constraint max_power_uw file, e.g., constraint_0_max_power_uw, is known to receive an ENODATA (No data available) error from the kernel for subzones. So even though the file exists, a value may not be printed for it.

It is possible for packages on multi-socket systems to be indexed out of order by the kernel. For example, the package at index 0 (-p 0) could actually be named package-1 while the package at index 1 (-p 1) is named package-0.

Report bugs upstream at <https://github.com/powercap/powercap>

FILES
/sys/devices/virtual/powercap/intel-rapl/*
/sys/class/powercap/intel-rapl/*

AUTHORS
Connor Imes <connor.k.imes@gmail.com>

SEE ALSO
powercap-info(1), powercap-set(1), rapl-set(1)